/*******************************************************************************
 * Copyright (c) 2010, 2013 THALES GLOBAL SERVICES.
 * This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *    Obeo - initial API and implementation
 *******************************************************************************/
package org.eclipse.sirius.diagram.ui.tools.internal.editor.tabbar;

import org.eclipse.gmf.runtime.diagram.ui.parts.IDiagramWorkbenchPart;

/**
 * A filler has the responsibility to fill a toolbar manager with contributions.
 * 
 * @author mchauvin
 */
public interface TabbarFiller {

    /**
     * Set the workbench part.
     * 
     * @param workbenchPart
     *            the workbench part
     */
    void setPart(IDiagramWorkbenchPart workbenchPart);

    /**
     * Fill the tab bar.
     */
    void fill();

    /**
     * Dispose the references to workbench, but not the filled contributions.
     */
    void dispose();
}
